<?php

class PollController extends Controller {

    var $idPoll = 0;
    var $obPoll;

    function __construct(&$web) {
        parent::__construct($web);
        $this->web->assign("title", "");
    }

    function indexAction() {
        if ($this->isPoll()) {
            $this->showPoll();
        } else {
            $this->web->show404page();
        }
    }

    function pAction() {
        if ($this->isPoll() && isset($_SESSION['idPollResolve'])) {
            $this->showPollP2();
        } else {
            $this->web->show404page();
        }
    }

    private function showPoll() {
        $this->web->assign("title", $this->obPoll->p_title);
        $idPoll = $this->idPoll;
        if ($_SERVER["REQUEST_METHOD"] == "POST") {
            $idPollResolve = $this->obPoll->resolveQueston($idPoll);
            if ($idPollResolve > 0) {
                if ($_POST['txt_pasofiltro'] == "1") {
                    $_SESSION['idPollResolve'] = $idPollResolve;
                    $this->goUrl($this->web->url(array("poll", "p", $this->web->avars[0])));
                } else {
                    $this->goUrl($this->web->url(array("poll", "thanks", $this->web->avars[0])));
                }
            } else {
                $this->goUrl($this->web->url(array("poll", $this->web->avars[0])));
                exit;
            }
        } else {
            /* Filtros */
            $this->showQuestions($idPoll, 1);
            /* Segmentos */
            $this->showSegments($idPoll);
            $this->web->show_page("poll_1.tpl");
        }
    }

    private function showPollP2() {
        $this->web->assign("title", $this->obPoll->p_title);
        $idPoll = $this->idPoll;
        if ($_SERVER["REQUEST_METHOD"] == "POST") {
            $this->obPoll->resolveQuestionQuestions($idPoll, $_SESSION['idPollResolve']);
            unset($_SESSION['idPollResolve']);
            $this->goUrl($this->web->url(array("poll", "thanks", $this->web->avars[0])));
        } else {
            /* Questions */
            $this->showQuestions($idPoll, 0);
            $this->web->show_page("poll_2.tpl");
        }
    }

    function thanksAction() {
        if ($this->isPoll()) {
            $this->web->assign("title", $this->obPoll->p_title);
            $this->web->show_page("poll_3.tpl");
        } else {
            $this->web->show404page();
        }
    }

    private function showQuestions($idPoll, $isFilter = 0) {
        $obPollQuestion = newClassMod("p_poll_question", "mod_poll");
        $rsPollQuestionFilters = $obPollQuestion->getAll("pq_p_id = '" . $idPoll . "' and cl_status = 1 and pq_filter = " . $isFilter, "cl_order");
        $html = "";
        if ($obPollQuestion->_DB->db_numrows($rsPollQuestionFilters) > 0) {

            if ($isFilter) {
                $html = "<div class='row row-form-app'><div class='col-lg-4'>
                    <div class='title-name'>
                        <div class='title-icon'><img src='" . SERVER_NAME . "/4app/assets/img/title/task.svg' alt=''></div>
                        <div class='title-content'><h4>Filtros</h4> <span class='img-comment'></span></div>
                    </div>
                </div><div class='col-lg-8'>
                    <div class='row'>";
            } else {
                $html = "";
            }
            $contador = 0;
            while ($rowPollQuestion = $obPollQuestion->nextrow($rsPollQuestionFilters)) {
                $html .= $this->getHmltQuestion($rowPollQuestion, $isFilter, $contador);
                $contador++;
            }
            if ($isFilter) {
                $html .= '</div></div></div>';
            }

            $this->web->assign("totalQuestions", $contador);
        }

        $this->web->assign("htmlQuestions", $html);
    }

    function showSegments($idPoll) {
        $obQuestionType = newClassMod("p_question_type", "mod_config");
        $rsQuestionType = $obQuestionType->getAll("(qt_type = 1 or qt_type = 3) and qt_id != 3 and cl_status = 1", "qt_type, qt_id");
        $html = "";
        if ($obQuestionType->_DB->db_numrows($rsQuestionType) > 0) {
            $contador = 1;
            $html = "<div class='row row-form-app'><div class='col-lg-4'>
                    <div class='title-name'>
                        <div class='title-icon'><img src='" . SERVER_NAME . "/4app/assets/img/title/discuss-issue.svg' alt=''></div>
                        <div class='title-content'><h4>Segmento</h4> <span class='img-comment'></span></div>
                    </div>
                </div><div class='col-lg-8'>
                    <div class='row'>";

            while ($rowQuestionType = $obQuestionType->nextrow($rsQuestionType)) {
                $segmentId = $rowQuestionType['qt_id'];
                $baseNameOption = 'txtseg_' . $segmentId;
                $class_content = "col-lg-6";
                if ($rowQuestionType['qt_type'] == "3") {
                    $class_content = "col-lg-12";
                }
                $html .= '<div class="' . $class_content . '"><div class="form-group"><label for="' . $baseNameOption . '">' . $rowQuestionType['qt_name'] . '</label>';
                if ($segmentId == 2) {
                    $html .= ' <input class="form-control required digits" name="' . $baseNameOption . '"  type="text" id="' . $baseNameOption . '" min="0"  maxlength="2" value="" />';
                } else {
                    $obQuestionTypeAnswer = newClassMod("p_question_type_answer", "mod_config");
                    $rsPollAnswer = $obQuestionTypeAnswer->getAll("qta_qt_id = '" . $segmentId . "' and cl_status = 1 ", "cl_order");

                    if ($rowQuestionType['qt_type'] == 3) {
                        if ($rowQuestionType['qt_answer_type'] == "1") {
                            while ($rowPollAnswer = $obQuestionTypeAnswer->nextRow($rsPollAnswer)) {
                                $html .= '<label class="checkbox"><input class="required" data-toggle="checkbox" type="checkbox"  name="' . $baseNameOption . '[]" value="' . $rowPollAnswer['qtr_id'] . '"> ' . $rowPollAnswer['qtr_answer'] . "</label>";
                            }
                        } else {
                            while ($rowPollAnswer = $obQuestionTypeAnswer->nextRow($rsPollAnswer)) {
                                $html .= '<label class="radio"><input class="required" data-toggle="radio" type="radio"  name="' . $baseNameOption . '" value="' . $rowPollAnswer['qtr_id'] . '"> ' . $rowPollAnswer['qtr_answer'] . "</label>";
                            }
                        }

                        $html .= '<label for="' . $baseNameOption . '" class="error"></label>';
                    } else {
                        $html .= '<select name="' . $baseNameOption . '" class="form-control select select-default required" data-toggle="select"> <option value="">- Seleccionar -</option>';
                        while ($rowPollAnswer = $obQuestionTypeAnswer->nextRow($rsPollAnswer)) {
                            $html .= '<option value="' . $rowPollAnswer['qtr_id'] . '">' . $rowPollAnswer['qtr_answer'] . '</option>';
                        }
                        $html .= '</select>';
                    }
                }
                $html .= '</div></div>';
            }
            $html .= "</div></div></div>";
        }
        $this->web->assign("htmlSegments", $html);
    }

    private function getHmltQuestion($rowQuestion, $isFilter, $contador) {
        $questionId = $rowQuestion["pq_id"];
        $baseNameOption = 'txt_' . $questionId;
        if ($rowQuestion['pq_qt_id'] == 7) {
            $baseNameOption = 'txt_' . $questionId . "[]";
        }
        if ($isFilter) {
            $html = '<div class="group-data clearfix"><div class="col-lg-12"><div class="title-group"><h6>' . $rowQuestion['pg_question'] . '</h6></div></div> <div class="col-lg-12">';
        } else {
            $displayQ = "";
            if ($contador > 0) {
                $displayQ = "display:none";
            }
            $html = '<div QuestionId="' . $rowQuestion['pq_id'] . '" sumTotalQuestion="' . $rowQuestion['pq_sumtotal'] . '" typeQuestionId="' . $rowQuestion['pq_qt_id'] . '" nameInput="' . $baseNameOption . '" style="' . $displayQ . '" id="tab' . $contador . '"><div class="sliding-contain"><div class="container"><div class="row"><div class="col-lg-6 col-lg-offset-4"><div class="title-name"><div class="title-icon"><img src="' . SERVER_NAME . '4app/assets/img/title/discuss-issue.svg" alt=""></div><div class="title-content"><h4>' . $rowQuestion['pg_question'] . '</h4><span class="img-comment"></span></div></div><div class="group-data clearfix">';
        }

        $html .= '<label for="' . $baseNameOption . '" class="error"></label>';

        $obPollAnswer = newClassMod("p_poll_answer", "mod_poll");
        $rsPollAnswer = $obPollAnswer->getAll("pa_pq_id = '" . $questionId . "' and cl_status = 1 ", "cl_order");


        $htmlActionClick = "";
        $isResolve = true;
        switch ($rowQuestion['pq_qt_id']) {
            case 16://Pregunta abierta
                $html .= '<input onkeyup="checkOption(' . $rowQuestion['pq_filter'] . ',' . $rowQuestion['pq_qt_id'] . ',0,\'' . $contador . '\')" name="' . $baseNameOption . '"  type="text" class="required questionval' . $contador . ' form-control" id="' . $baseNameOption . '"  maxlength="100" value="" />';
                break;
            case 9://Ordinal
            case 10://Fraccionamiento
                $html_adicional_val = "";
                if ($rowQuestion['pq_qt_id'] == 9) {
                    $numPollAnswer = $obPollAnswer->_DB->db_numrows($rsPollAnswer);
                    $html_adicional_val = 'max="' . $numPollAnswer . '" min=1';
                } else {
                    
                }

                while ($rowPollAnswer = $obPollAnswer->nextRow($rsPollAnswer)) {
                    $baseNameOption_here = $baseNameOption . "[" . $rowPollAnswer['pa_id'] . "]";
                    $html .= '<div class="form-inline">';
                    $html .= '<div class="form-group"><input ' . $html_adicional_val . ' style="max-width: 100px;" onkeyup="checkOption(' . $rowQuestion['pq_filter'] . ',' . $rowQuestion['pq_qt_id'] . ',0,\'' . $contador . '\')" name="' . $baseNameOption_here . '"  type="text" class="required digits numeric questionval' . $contador . ' form-control" id="' . $baseNameOption_here . '" size=5  maxlength="100" value="" /> ' . $rowPollAnswer['pa_answer'] . "</div>";
                    $html .= '</div>';
                }

                break;
            case 7:// Respuesta múltimple
                while ($rowPollAnswer = $obPollAnswer->nextRow($rsPollAnswer)) {
                    $htmlActionClic = "";
                    if ($isResolve) {
                        $htmlActionClick = 'onclick = "checkOption(' . $rowQuestion['pq_filter'] . ',' . $rowQuestion['pq_qt_id'] . ',' . $rowPollAnswer['pa_value'] . ',\'' . $contador . '\')"';
                    }
                    $html .= '<label class="checkbox"><input class="required questionval' . $contador . '" type="checkbox" data-toggle="checkbox" ' . $htmlActionClick . ' name="' . $baseNameOption . '" value="' . $rowPollAnswer['pa_id'] . '"> ' . $rowPollAnswer['pa_answer'] . "</label>";
                }
                break;
            default: //Repuesta única
                while ($rowPollAnswer = $obPollAnswer->nextRow($rsPollAnswer)) {
                    $htmlActionClick = "";
                    if ($isResolve) {
                        $htmlActionClick = 'onclick = "checkOption(' . $rowQuestion['pq_filter'] . ',' . $rowQuestion['pq_qt_id'] . ',' . $rowPollAnswer['pa_value'] . ',\'' . $contador . '\')"';
                    }
                    $html .= '<label class="radio"><input class="required questionval' . $contador . '" data-toggle="radio" type="radio" ' . $htmlActionClick . ' name="' . $baseNameOption . '" value="' . $rowPollAnswer['pa_id'] . '"> ' . $rowPollAnswer['pa_answer'] . "</label>";
                }
        }
        if ($isFilter) {
            $html .= '</div> </div>';
        } else {
            $html .= '</div></div></div></div></div></div>';
        }


        return $html;
    }

    private function isPoll() {
        if (isset($this->web->avars[0])) {
            $this->idPoll = ($this->web->avars[0] / 987);
            if ($this->idPoll > 0) {
                $this->obPoll = newClassMod("p_poll", "mod_poll");
                $this->obPoll->getRow($this->idPoll);
                if ($this->obPoll->cl_status != 2) {
                    $this->idPoll = 0;
                }
            }
        }
        if ($this->idPoll > 0) {
            return true;
        } else {
            return false;
        }
    }

}

?>
