<?php

/**
 * Clase para Conectar a Base de Datos MYSQL 
 * @author Eliezer Benjam�n Gonzales Basilio <egonzales@ispgraf.com>
 * @version 1.0.1
 * @date 01/08/2005
 * @copyright ISPGRAF.SAC - http://www.ispgraf.com
 */
class db {

    var $_host;
    var $_user;
    var $_pass;
    var $_db;
    var $_linkID;
    var $_query_result;
    var $_row;
    var $_v;

    function db($inHost, $inUser, $inPass, $inDatabase, $inPersistency = false) {
        $this->_host = $inHost;
        $this->_user = $inUser;
        $this->_pass = $inPass;
        $inPersistency == false ? $this->db_connect() : $this->db_pconnect();
        $this->_db = $this->set_db($inDatabase);
    }

    function db_connect() {
        $this->_linkID = @mysql_connect($this->_host, $this->_user, $this->_pass)
                or die($this->db_printError(mysql_errno()));
    }

    function db_pconnect() {
        $this->_linkID = @mysql_pconnect($this->_host, $this->_user, $this->_pass)
                or die($this->db_printError(mysql_errno()));
    }

    function set_db($inDb) {
        mysql_select_db($inDb, $this->_linkID)
                or die($this->db_printError(mysql_errno()));
    }

    function db_close() {
        @mysql_free_result($this->_query_result);
        @mysql_close($this->_linkID);
    }

    //metodos SQL
    function db_query($inQuery = "", $cache = false) {
        $cache = false;
        unset($this->_query_result);
        if ($inQuery != "") {
            //echo $inQuery."<br>----<br>";
            return $this->cache($inQuery, $cache);
        } else {
            $this->db_printError(1);
            return false;
        }
    }

    function cache($inQuery, $cache) {
        $operation = strtolower($this->getWirstWord($inQuery));

        switch ($operation) {
            case "select":
                if ($cache) {
                    return $this->excecuteCache($inQuery);
                } else {
                    $this->_query_result = $this->excecuteQuery($inQuery);
                }
                break;
            case "describe":
                return $this->excecuteCache($inQuery);
                break;

            default:
                $this->_query_result = $this->excecuteQuery($inQuery);
        }


        return $this->_query_result;
    }

    /** Metodo para crar y dar permiso al directorio
     * @access public
     * */
    function CrearDirectorio($directory) {

        if (!is_dir($directory)) {
            if (@mkdir($directory)) {
                @chmod($directory, 0777);
                return true;
            } else {
                return false;
            }
        } else {
            return true;
        }
    }

    function excecuteCache($inQuery) {

        $cache_name = $this->getCacheName($inQuery);
        $dir_cache = PATH_ADMIN . "library/cache/" . strtolower($this->getWirstWord($inQuery)) . "/" . $cache_name;
        if (is_file($dir_cache)) {
            return $this->readFileCache($dir_cache);
        } else {

            $rs = $this->excecuteQuery($inQuery);
            $this->createCache($rs, $dir_cache);
            //$rs =  $this->excecuteQuery($inQuery);
            $rs = $this->db_query($inQuery, true);
            return $rs;
        }
    }

    function readFileCache($file) {
        $lines = file($file);
        $rs = "";
        for ($i = 0; $i < count($lines); $i++) {
            $rs .= $lines[$i];
        }
        //var_dump(unserialize($rs));exit;
        return unserialize($rs);
    }

    function createCache($rs, $dir) {
        if (!is_dir($dir)) {
            $this->CrearDirectorio(str_replace(basename($dir), "", $dir));
        }
        $rss[] = "";
        while ($row = mysql_fetch_array($rs)) {
            $rss[] = $row;
        }
        //$rss['cont'] = -1;
        $rsss = serialize($rss);

        $fp = fopen($dir, 'w') or die('Failed opening file');
        fwrite($fp, $rsss);
        fclose($fp);
    }

    function excecuteQuery($inQuery) {
        //echo $inQuery."<br><hr>"; 
        if ($this->_query_result = mysql_query($inQuery, $this->_linkID)) {
            
        } else {
            $this->db_printError(mysql_errno());
            $this->_query_result = false;
        }
        return $this->_query_result;
    }

    function getCacheName($inQuery) {
        $md5cache = strtolower($inQuery);
        //echo $md5cache."<br>";
        $md5cache = str_replace(" ", "", $md5cache);
        $md5cache = str_replace("select", "", $md5cache);
        $md5cache = str_replace("where", "", $md5cache);
        $md5cache = str_replace("orderby", "", $md5cache);
        $md5cache = str_replace("limit", "", $md5cache);
        $md5cache = str_replace(" ", "", $md5cache);
        $md5cache = str_replace(",", "", $md5cache);
        //$md5cache = base64_encode($md5cache);
        //echo $md5cache."<br>";
        $md5cache = md5($md5cache);
        //echo $md5cache."<br><br>";
        return $md5cache;
    }

    function getWirstWord($inQuery) {
        $a = explode(" ", trim($inQuery));
        return trim(@$a[0]);
    }

    function db_nextrow_objet($inQuery_id = 0) {

        if ($inQuery_id) {
            $this->_row[$inQuery_id] = mysql_fetch_object($inQuery_id);
            return $this->_row[$inQuery_id];
        } else {
            return false;
        }
    }

    function parceRsToArray($rs) {
        $a_res = array();
        while ($row = $this->db_nextrow_objet($rs)) {
            $a_res[] = $row;
        }
        return $a_res;
    }

    function db_fetchrow(&$inQuery_id = 0) {

        if ($inQuery_id) {
            if (is_resource($inQuery_id)) {
                //$this->_row[$inQuery_id] = mysql_fetch_array($inQuery_id);
                return mysql_fetch_assoc($inQuery_id);
            } elseif (is_array($inQuery_id)) {
                return next($inQuery_id);
            } else {
                return false;
            }

            //var_dump($this->_row[$inQuery_id])."<br>";
            return $this->_row[$inQuery_id];
        } else {
            return false;
        }
    }

    function db_numrows(&$inQuery_id = 0) {
        if (!$inQuery_id) {
            $inQuery_id = $this->_query_result;
        }

        if ($inQuery_id) {
            if (is_resource($inQuery_id)) {
                $result = @mysql_num_rows($inQuery_id);
            } elseif (is_array($inQuery_id)) {

                $result = count($inQuery_id) - 1;
            } else {
                $result = 0;
            }

            return $result;
        } else {
            return false;
        }
    }

    /**
     * Returns the column descriptions for a table.
     *
     * @return array
     */
    function db_dscTable($inTable) {
        $sql = "DESCRIBE $inTable";
        $result = $this->db_query($sql);

        $data = array();
        while ($row = $this->db_fetchrow($result)) {
            // var_dump($row);
            $data[] = $row;
        }

        //exit;
        $descr = "";
        foreach ($data as $key => $val) {
            $descr[$val['Field']] = array(
                'name' => $val['Field'],
                'type' => $val['Type'],
                'notnull' => (bool) ($val['Null'] === ''), // not null is empty, null is yes
                'default' => $val['Default'],
                'primary' => (strtolower($val['Key']) == 'pri'),
            );
        }
        return $descr;
    }

    function db_printError($errNum = 0) {
        /* if(!include_once("library/errorHand_mysql.php"))
          {
          echo  mysql_error($this->_linkID)." ";
          echo  mysql_errno($this->_linkID)." ";
          } */

        $GLOBALS['TYPEMSG'] = "error";
        $GLOBALS['MSGBOX'] = mysql_error($this->_linkID) . " " . mysql_errno($this->_linkID);
        echo $GLOBALS['MSGBOX']; exit;
    }

    function db_nunCols($result) {
        return mysql_numfields($result);
    }

    function db_numrowsr($result) {
        return mysql_num_rows($result);
    }

    function db_add_date($date, $interval, $type, $format = "%Y-%m-%d") {
        $sql = "select DATE_FORMAT(DATE_ADD('" . $date . "',INTERVAL " . $interval . " " . $type . "),'" . $format . "') as date";
        $rs_date = $this->db_query($sql);
        $row_date = $this->db_fetchrow($rs_date);
        return $row_date['date'];
    }

    function db_sub_date($date, $interval, $type, $format = "%Y-%m-%d") {
        $sql = "select DATE_FORMAT(DATE_SUB('" . $date . "',INTERVAL " . $interval . " " . $type . "),'" . $format . "') as date";
        $rs_date = $this->db_query($sql);
        $row_date = $this->db_fetchrow($rs_date);
        return $row_date['date'];
    }

}

?>