<?php 
//require_once("class.NokTemplate.php");
//require_once("class.FastTemplate.php3");

class template
{

	var $_tpl;
	var $_dir_template;

	function template() 
	{
		$this->_tpl = null;
		$this->_dir_template = null;
	}

	function get_dir_template() 
	{
		return $this->_dir_template;
	}

	function set_dir_template($dir_template) {
		$ok = false;

		if(is_dir($dir_template)) 
		{
			$this->_dir_template = $dir_template;
			$ok = true;
		}

		return $ok;
	}

	function open() {}

	function load($id_archivo, $archivo) {}

	function set_block($id_block, $id_archivo) {}

	function assign($id_valor, $valor, $tipo_valor = 0, $operador = "") {}

	function show($id) {}

} //Fin clase abstracta "template"


/****************************************************************************************************************************/
/* Clase tpl_nok_template (usa la clase NokTemplate)                                                                        */
/****************************************************************************************************************************/

class tpl_nok_template extends template {

	function tpl_nok_template() 
	{
		parent::template();
	}

	function open() 
	{
		$this->tpl = new NokTemplate($this->_dir_template);
	}

	function load($id_archivo, $archivo) 
	{
		if(file_exists($this->_dir_template.$archivo)) 
		{
			$this->tpl->cargar($id_archivo, $archivo);
		}
	}

	function set_block($id_block, $id_archivo) 
	{
		$this->tpl->definirBloque($id_block, $id_archivo);
	}

	function assign($id_valor, $valor, $tipo_valor = 0, $operador = "") 
	{
		if($tipo_valor == 0) 
		{
			if(is_object($valor))
			{
				
				//var_dump( $valor->_columnas ); exit;
				if(isset($valor->_columnas) && is_array($valor->_columnas))
				{
					foreach($valor->_columnas as $col_name => $col_values)
					{						
						$this->tpl->asignar($col_name, $valor->$col_name);
					}
				}
			}else
			{
				$this->tpl->asignar($id_valor, $valor);
			}
			
		} 
		else 
		{
			$this->tpl->expandir($id_valor, $operador.$valor);
		}
	}

	function show($id) 
	{
		$this->tpl->expandir("FINAL", $id);
		$this->tpl->imprimir("FINAL");
	}

} //Fin clase "tpl_nok_template"


/****************************************************************************************************************************/
/* Clase tpl_fast_template (usa la clase FastTemplate)                                                                      */
/****************************************************************************************************************************/

class tpl_fast_template extends template {

	function tpl_fast_template() {
		parent::template();

	}

	function open() {
		$this->tpl = new FastTemplate($this->_dir_template);
	}

	function load($id_archivo, $archivo) {
		if(file_exists($this->_dir_template.$archivo)) {
			$this->tpl->define(array($id_archivo => $archivo));
		}
	}

	function set_block($id_block, $id_archivo) {
		$this->tpl->define_dynamic($id_block, $id_archivo);
	}

	function assign($id_valor, $valor, $tipo_valor = 0, $operador = "") {
		if($operador == "+") {
			$operador = ".";
		}

		if($tipo_valor == 0) {
			$this->tpl->assign("{".$id_valor."}", $valor);
		} else {
			$this->tpl->parse("{".$id_valor."}", $operador.$valor);
		}
	}

	function show($id) {
		$this->tpl->parse("FINAL", $id);
		$this->tpl->FastPrint("FINAL");
	}

} //Fin clase "tpl_fast_template"


?>